from typing import Any, Iterator

from ..base import BaseSolver


class Solver(BaseSolver):
    def solve(self, input: str) -> Iterator[Any]:
        lines = input.splitlines()

        values = [int(line) for line in lines]

        # part 1
        yield sum(v2 > v1 for v1, v2 in zip(values[:-1], values[1:]))

        # part 2
        runnings = [sum(values[i : i + 3]) for i in range(len(values) - 2)]
        yield sum(v2 > v1 for v1, v2 in zip(runnings[:-1], runnings[1:]))
