from collections import Counter
from typing import Any, Iterator

from ..base import BaseSolver


class Solver(BaseSolver):
    def solve(self, input: str) -> Iterator[Any]:
        values = list(map(int, input.split()))

        column_1 = sorted(values[::2])
        column_2 = sorted(values[1::2])

        yield sum(abs(v1 - v2) for v1, v2 in zip(column_1, column_2, strict=True))

        counter_2 = Counter(column_2)
        yield sum(value * counter_2.get(value, 0) for value in column_1)
