import json
import sys
from datetime import datetime
from typing import Any, Literal, TextIO


def _datetime_formatter(value: Any) -> Any:
    if isinstance(value, datetime):
        return value.isoformat()
    else:
        return value


def dump_api_message(
    type: Literal[
        "log", "answer", "file", "progress-start", "progress-step", "progress-end"
    ],
    content: Any,
    file: TextIO = sys.stdout,
):
    print(
        json.dumps(
            {"type": type, "time": datetime.now(), "content": content},
            default=_datetime_formatter,
        ),
        flush=True,
        file=file,
    )
